#pragma once

#include <stddef.h>
#include "MDM.h"

/**
 * Device Memory storage handler
 */
class DeviceMemory
{
public:
    DeviceMemory(MDMSerial&);
    
    /** loads configuration from persistent memory */
    bool loadConfiguration(char*, size_t);
    
    /** saves configuration to persistent memory */
    bool saveConfiguration(char*);
    
    /** removes configuration from persistent memory */
    bool resetConfiguration();

private:
    MDMSerial& _mdm;
};
